/*******************************************************}
{                                                       }
{       File: demuxer.h                                 }
{       Created by Tsviatko Jongov                      }
{       http://tsviatko.jongov.com                      }
{       Date : 25.01.2007                               }
{                                                       }
{       CMpeg2Demux class.                              }
{                                                       }
{*******************************************************/
#include "stdafx.h"
#include "buffer.h"

//MPEG-2 start codes
#define SYSTEM_START_CODE_MIN     0x000001B9
#define SYSTEM_START_CODE_MAX     0x000001FF
#define PACK_START_CODE           0x000001BA
#define SYSTEM_START_CODE         0x000001BB

//MPEG-2 stream IDs
#define PROGRAM_STREAM_MAP        0xBC
#define PADDING_STREAM            0xBE
#define PRIVATE_STREAM_2          0xBF
#define ECM_STREAM                0xF0
#define EMM_STREAM                0xF1
#define PROGRAM_STREAM_DIRECTORY  0xFF
#define DSM_CC_STREAM             0xF2
#define ITU_T_STREAM_E            0xF8

typedef int ReceiveFunction(unsigned char StreamID, void * Data, int Size);

static _inline unsigned int asm_swap32(unsigned int x); 
static _inline unsigned short asm_swap16(unsigned short x);

class CMpeg2Demux {
private:
	CBuffer * fBuffer; 
	ReceiveFunction * fReceiveFunction;

	int Demultiplex();
public:
	CMpeg2Demux();
	~CMpeg2Demux();
	int AddData(void * Data, int Size);
	void SetReceiveFunction(ReceiveFunction * func);	
};