/*******************************************************}
{                                                       }
{       File: demuxer.cpp                               }
{       Created by Tsviatko Jongov                      }
{       http://tsviatko.jongov.com                      }
{       Date : 25.01.2007                               }
{                                                       }
{       Mpeg2Demux main.                                }
{                                                       }
{*******************************************************/
#include "stdafx.h"
#include "output.h"
#include "demuxer.h"

char fName[MAX_PATH];	
unsigned char buff[1024 * 1024];

//Output
COutput * output[256];
int output_cnt;
unsigned char output_ids[256];

int get_output_index(int StreamID)
{
	for (int i = 0; i < output_cnt; i++)
	{
		if (output_ids[i] == StreamID)
		{
			return i;
		}
	}

	return -1;
}

void free_output()
{
	for (int i = 0; i < output_cnt; i++)
	{
		if (output[i] != NULL)
			delete output[i];		
	}
}

int Receive(unsigned char StreamID, void * Data, int Size)
{
	try
	{
		int idx = get_output_index(StreamID);
		if (idx < 0)
		{
			output[output_cnt] = new COutput(StreamID, fName);
			output_ids[output_cnt] = StreamID;
			idx = output_cnt;
			output_cnt++;
		}

		output[idx]->WriteData((char *)Data, Size);

		return 0;
	}
	catch (...)
	{		
		printf("tsv: Error in Receive call...\n");
	}
};

int _tmain(int argc, _TCHAR* argv[])
{
	FILE * source;
	int read;

	if (argc != 2)
	{
		printf("MPEG-2 program stream demultiplexer.\n");
		printf("Created by Tsviatko Jongov (http://tsviatko.jongov.com).\n");
		printf("Performs MPEG-2 program stream file demultiplexing.\n");
		printf("\n");
		printf("Usage:\n");
		printf("MPEG2DEMUX source\n");
		printf("  source Specifies the file to be demultiplexed.\n");
		return 0;
	}

	strcpy(fName, argv[1]);

	CMpeg2Demux * dem = new CMpeg2Demux();
	dem->SetReceiveFunction(&Receive);

	source = fopen(fName, "rb");

	while (1) 
	{	
		read = fread(&buff[0], sizeof(char), 100 * 1024, source);
		if (read <= 0)
		{
			break;
		}

		dem->AddData(&buff[0], read);
	}

	fclose(source);
	delete dem;
	free_output();

	return 0; 
}

