/*******************************************************}
{                                                       }
{       File: output.cpp                                }
{       Created by Tsviatko Jongov                      }
{       http://tsviatko.jongov.com                      }
{       Date : 25.01.2007                               }
{                                                       }
{       COutput class.                                  }
{                                                       }
{*******************************************************/
#include "stdafx.h"
#include "output.h"

void ChangeFileExtension(char * FileName, char * NewExtension)
{	
 	char * dot = strrchr(FileName, '.');
 	int lenToExt = strlen(FileName) - (dot ? strlen(dot) : 0);
 	strncpy(FileName, FileName, lenToExt);
 	strcpy(FileName + lenToExt , NewExtension);
}

COutput::COutput(unsigned char StreamID, char * FileName) 
{
	try
	{	
		fStreamID = StreamID;	
		strcpy(fFileName, FileName);
	
		char ext[MAX_PATH];	
		sprintf(ext, ".%.2x.bin", StreamID);	
		strupr(ext);	
		ChangeFileExtension(fFileName, ext);

		fOutputFile = fopen(fFileName, "wb");
		if (fOutputFile == NULL) 
		{
		  printf("tsv: Error in COutput::COutput - can not open file %s\n", fFileName);
		  throw 0;
		}
	}
	catch(...)
	{
		printf("tsv: Error in COutput::COutput call...\n");
	}
};

COutput::~COutput() 
{
	try
	{
		if (fOutputFile != NULL) 
		{
		  fclose(fOutputFile);
		}
	}
	catch(...)
	{
		printf("tsv: Error in COutput::~COutput call...\n");
	}
};

void COutput::WriteData(char * Data, int DataSize)
{
	try
	{
		if (fOutputFile == NULL) 
		{		
			printf("tsv: Error in COutput::WriteData - no file opened.\n");
			throw 0;
		}
  
		fwrite(Data, sizeof(char), DataSize, fOutputFile);
	}
	catch(...)
	{
		printf("tsv: Error in COutput::WriteData call...\n");
	}
}
